package cokr.xit.fims.sprt.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.sprt.CvlcptDscsnCn;
import cokr.xit.fims.sprt.SprtQuery;

/**업무지원 - 민원 상담 내용 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-09-05	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("cvlcptDscsnCnMapper")
public interface CvlcptDscsnCnMapper extends AbstractMapper {

	/**지정한 조건에 따라 민원 상담 내용 목록을 조회하여 반환한다.<br />
	 * @param req 민원 상담 내용 조회 조건
	 * @return 민원 상담 내용 목록
	 */
	List<DataObject> selectCvlcptDscsnCnList(SprtQuery req);

	/**지정한 조건에 따라 민원 상담 내용 객체들을 반환한다.
	 * @param req 민원 상담 내용 조회 조건
	 * @return 민원 상담 내용 객체 목록
	 */
	List<DataObject> selectCvlcptDscsnCns(SprtQuery req);

	/**지정한 조건에 따라 민원 상담 내용 대장 객체의 마지막 1개를 반환한다.
	 * @param cvlcptDscsnId 민원 상담 ID
	 * @return 민원 상담 내용 대장 객체
	 */
	default DataObject selectCvlcptDscsnCnInfo(SprtQuery req) {
		List<DataObject> cvlcptDscsnCns = selectCvlcptDscsnCns(req);

		return !cvlcptDscsnCns.isEmpty() ? cvlcptDscsnCns.get(0) : null;
	}

	/**지정한 단속 ID의 단속 정보를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속 정보
	 */
	DataObject selectCrdn(SprtQuery req);

	/**민원 상담 내용 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"cvlcptDscsnCn" - 민원 상담 내용</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertCvlcptDscsnCn(Map<String, Object> params);

	/**민원 상담 내용 정보를 등록한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(CvlcptDscsnCn cvlcptDscsnCn) {
		return cvlcptDscsnCn != null && insertCvlcptDscsnCn(params().set("cvlcptDscsnCn", cvlcptDscsnCn)) == 1;
	}

	/**민원 상담 내용 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"cvlcptDscsnCn" - 민원 상담 내용</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateCvlcptDscsnCn(Map<String, Object> params);

	/**민원 상담 내용 정보를 수정한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(CvlcptDscsnCn cvlcptDscsnCn) {
		return cvlcptDscsnCn != null && updateCvlcptDscsnCn(params().set("cvlcptDscsnCn", cvlcptDscsnCn)) == 1;
	}

	/**지정한 민원 상담 내용을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"cvlcptDscsnCn" - 민원 상담 내용</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteCvlcptDscsnCn(Map<String, ?> params);

	/**민원 상담 내용 정보를 삭제한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(CvlcptDscsnCn cvlcptDscsnCn) {
		return cvlcptDscsnCn != null && deleteCvlcptDscsnCn(params().set("cvlcptDscsnCn", cvlcptDscsnCn)) == 1;
	}

}
